﻿// AutoNumbes
////An InDesign CS3, CS4 JavaScript
//
main();
function main(){
	if(app.documents.length == 0)
	{
		alert("Не открыт документ", "фатальная ошибка")
		exit()
	}
myDialog()

}

function myDialog()
{
var objStyleNames = myGetObjStyleNames()

var myDialog = app.dialogs.add({name:"Автонумератор", canCancel:true});
with(myDialog.dialogColumns.add()){
	with(borderPanels.add()){
		with(dialogColumns.add()){				
			with(dialogRows.add()){
				staticTexts.add({staticLabel:"Выберите объектный стиль"});
			}
			with(dialogRows.add()){
				var objStyleDropdown = dropdowns.add( {stringList : objStyleNames, selectedIndex : 0, minWidth : 230 });
			}
		} // dialogColumns.add
	} // borderPanels
	with(borderPanels.add()){
		with(dialogColumns.add()){
			with(dialogRows.add()){
				staticTexts.add({staticLabel:"Префикс"});
			}
			with(dialogRows.add()){
				var myPrefixTextField = textEditboxes.add({editContents:"", minWidth:50});
			}		
		} // dialogColumns.add 
		with(dialogColumns.add()){
			with(dialogRows.add()){
				staticTexts.add({staticLabel:"Начальный номер"});
			}
			with(dialogRows.add()){ // textEditboxes.add
				var myNumberTextField = textEditboxes.add({editContents:"", minWidth:100}); 
			}		
		} // dialogColumns.add 
		with(dialogColumns.add()){
			with(dialogRows.add()){
				staticTexts.add({staticLabel:"Суффикс"});
			}
			with(dialogRows.add()){
				var mySuffixTextField = textEditboxes.add({editContents:"", minWidth:50});
			}		
		} // dialogColumns.add 
	} // borderPanels.add
	with(borderPanels.add()){
		with(dialogColumns.add()){
			with(dialogRows.add()){
				staticTexts.add({staticLabel:"Приращение на: "});
				var myDeltaTextField = integerEditboxes.add({editContents:"1", minWidth:25});//integerEditboxes.add({editValue:"", minimumValue:1, maximumValue:9999});

			}
		
		} // dialogColumns.add 
	} // borderPanels.add
	staticTexts.add({staticLabel:"(c) www.adobeindesign.ru"});
} // with(dialogColumns.add())
var myResult = myDialog.show();
if(myResult == true){ // если пользователь нажал ОК
	// забираем данные из диалога и закрываем его
	var myObjectStyleIndex = objStyleDropdown.selectedIndex;
	myObjStyle = myGetObjStyleByName(objStyleNames[myObjectStyleIndex])
	var myPrefix =myPrefixTextField.editContents;
    if (isNaN(myNumberTextField.editContents)) {
            alert("Неправильно введен номер. Должны быть введены только цифры")
            myDialog.destroy();
            exit();
		}
	var myStartNumberStr = myNumberTextField.editContents
	var mySuffix = mySuffixTextField.editContents;
	var myDelta = myDeltaTextField.editValue;
	//var myNPr = myNPrTextField.editValue;
    // закрываем диалог
	myDialog.destroy();
    // небольшая проверка
    if(myDelta <= 0) { 
		alert("Приращение не должно быть отрицательным числом")
		exit() } //  приращение не должно быть равным или меньше нуля
 	// вызов основной ф-ции по нумерации
	autoNumber1( myObjStyle, myPrefix, myStartNumberStr, mySuffix, myDelta);
}
else {	myDialog.destroy(); }

} // fnc myDialog()
//---------------------------------------------------------------------------------------------------------------------------------------
function autoNumber1( myObjStyle, myPrefix, myStartNumberStr, mySuffix, myDelta )
{
	// Определяем, есть ли в документе текстовые фреймы с объектным стилем для обработки
	var areFrames =areFramesWithmyObjStyle(myObjStyle)
	if(!areFrames)
	{
		alert("В документе нет фреймов с заданным объектным стилем", "Ошибка");
		exit();
       }
   var myNumberStr = myStartNumberStr
   var myStartNumber = parseInt(myStartNumberStr, 10)
   var myNumber = parseInt(myStartNumberStr)
   var pages = app.documents[0].pages.everyItem().getElements();
   var k=0
   for(var j =0; j<pages.length; j++){  
	   // alert("на странице фреймов "+pages[j].textFrames.length)
       for(var i=0; i< pages[j].textFrames.length; i++) {
          myTextFrame = pages[j].textFrames[i]
          if(myTextFrame.appliedObjectStyle != myObjStyle) { continue;}
              if(!k) 
                  { myTextFrame.contents =   myPrefix + myStartNumberStr + mySuffix; k++;}
               else {
                    myNumber = myNumber + myDelta
                    myNumberStr = myNumber.toString()
                    if(myNumberStr.length  < myStartNumberStr.length)
                    {
                        myNumberStr = myNumbersConsolidation(myNumberStr, myStartNumberStr)
                     } // if
                 myTextFrame.contents =   myPrefix + myNumberStr + mySuffix;

             } // else
         } // for
     } // for

 } // fnc
function autoNumber( myObjStyle, myPrefix, myStartNumberStr, mySuffix, myDelta )
{
	// Определяем, есть ли в документе текстовые фреймы с объектным стилем для обработки
	var areFrames =areFramesWithmyObjStyle(myObjStyle)
	if(!areFrames)
	{
		alert("В документе нет фреймов с заданным объектным стилем", "Ошибка");
		exit();
       }
   var myTextFrames = app.documents[0].textFrames.everyItem().getElements();
   var myNumberStr = myStartNumberStr
   var myStartNumber = parseInt(myStartNumberStr, 10)
   var myNumber;
   var myNumberStr;
	for( var i=0; i < myTextFrames.length; i++)
	{
		if(myTextFrames[i].appliedObjectStyle != myObjStyle)
		{ continue;}
        if(i>0) {
            myNumber = myStartNumber + i*myDelta
            myNumberStr = myNumber.toString()
            if(myNumberStr.length  < myStartNumberStr.length)
            {
                myNumberStr = myNumbersConsolidation(myNumberStr, myStartNumberStr)
             }
         }
         myTextFrames[i].contents =   myPrefix + myNumberStr + mySuffix;
	} // for
   
} // fnc

function myNumbersConsolidation(shtStr, lngStr)
{
 var sLen =    shtStr.length;
 var lLen = lngStr.length;
 var dLen = lLen - sLen;
 var nStr = lngStr.substr(0,dLen)
 return nStr+shtStr ;
 }

function areFramesWithmyObjStyle(myObjStyle)
{
	var myTextFrames = app.documents[0].textFrames.everyItem().getElements();
	for( var i=0; i < myTextFrames.length; i++)
	{
		if(myTextFrames[i].appliedObjectStyle == myObjStyle)
		{ return 1;}
	} // for

return 0;
} // fnc()

function myGetObjStyleNames()
// Получаем список объектных стилей  
{
	var curGroup;
	var curGroupName;
	var curNameInGroup;
	var myObjStyleNames = app.activeDocument.objectStyles.everyItem().name;
	myObjStyleNames.shift(); // удаление стиля NoNe
	var objGroups = app.activeDocument.objectStyleGroups;
	var objGroupsLen = objGroups.length; // количество папок
	// цикл по папкам (группам)
	for(var i = 0; i < objGroupsLen; i++) {
		curGroup = objGroups[i];
		curGroupName = objGroups[i].name; // 
		curGroupStyleNames = curGroup.paragraphStyles.everyItem().name
		// добавляем к общему списку стили из групп
		for (j=0; j< curGroupStyleNames.length; j++)
		{
			curNameInGroup = curGroupName +":"+ curGroupStyleNames[j];
			myObjStyleNames.push(curNameInGroup);
		}
	}
	return myObjStyleNames;
}

function myGetObjStyleByName(myStyleName)
{
	var DocObjStyles = app.activeDocument.objectStyles;
	var DocObjGroups = app.activeDocument.objectStyleGroups;
	myStyleName = ""+myStyleName;
	var pos = myStyleName.indexOf(":")
	if(pos == -1)
	{
	// стиль не в группе
	var myStyle = DocObjStyles.item(myStyleName);
		return myStyle;
	} //if
	else
	{
		var myGroupAndStyleNames = myStyleName.split(":")
		var myGroupName = myGroupAndStyleNames[0];
		var myStyleName = myGroupAndStyleNames[1];
		var myGroup =DocParaGroups.item(myGroupName);
		return myGroup.objectStyles.item(myStyleName);

	}
} // fnc